!- TRIANGULAR μOS 1.42 for Commodore 128
!- SIMCITY


!- SIMCITYstart & set up
0j=.:m=8:h8=26:v8=52:h7=338:v7=212:q$=chr$(34):v=132:h=186:r0=.:c0=.:i0=.:r1=.:c1=.:i1=.:f=.:e=.:y=.:bd=peek(3000):s=peek(3070):g=peek(2619)*256:c=55296:fori=1to8:spritei,.:next:v$="{down*24}":h$="{right*40}":print"{home*2}{clear}{142}{27}m":goto74

!- SIMCITY mouse click handling   h=h/8-26:v=v/8-52
1return
2v=v-m:ifv<v8thenv=v8:return:elsereturn
3gosub2:gosub4:return
4h=h+m:ifh>h7thenh=h7:return:elsereturn
5gosub4:gosub6:return
6v=v+m:ifv>v7thenv=v7:return:elsereturn
7gosub6:gosub8:return
8h=h-m:ifh<h8thenh=h8:return:elsereturn
9gosub2:gosub8:return

!- Convert mouse sprite position to window loop objects position
10h0=int((h-h8)/m):v0=int((v-v8)/m):return

!- Create mouse pointer
11movspr1,.#.:movspr1,h,v:sprite1,1,5,.,.,.,.:return

!- Init game values & draw black space background for color memory
12 v=132:h=170:r0=.:r1=.:c0=.:c1=.:i0=.:i1=.:f=1000:e=.:y=2000:print"{black}{home*2}{clear}":window.,21,39,24:print"{27}m{black}{reverse on}U";:gosub32:print"{reverse on}I{return}{reverse on}Bpopulation:{space*12}${space*14}BByear: {left}"int(y)"{left}   {blue}f1{black} load  {blue}f2{black} save  {red}f8{black} exitB{return}{reverse on}J";:gosub32:print"{reverse on}K":gosub11

!- SIMCITY loop
13e=e+1:window.,22,39,23:print"{black}{reverse on}"tab(12)(r0*200+r1*400)"{left}  "tab(23)f"{left}   {return}{reverse on}"tab(6)int(y)tab(23)"{up}$":ife>=10thene9=e9+1:e=.:gosub33
14movspr1,h,v:j=(joy(2)and15)+1:onjgosub1,2,3,4,5,6,7,8,9:gosub10
15getk$:ifk$=""then13
16movspr1,h,v:ifk$=" "andpeek(g+v0*s+h0)=32andf>9thenpoke(g+v0*s+h0),186:poke(c+v0*s+h0),64:f=f-10
17ifk$="{f8}"then74
18ifk$="{f1}"thengosub62
19ifk$="{134}"thengosub68
20ifk$="{20}"andpeek(g+v0*s+h0)<>32andf>99thengosub54
21ifk$<>" "thengosub23
22goto13

!- Ckeck key for zone
23 ifk$="r"andf>=200thengosub27:ifep<1thencl$="{light green}":gosub31:f=f-200
24 ifk$="c"andf>=800thengosub27:ifep<1thencl$="{light blue}":gosub31:f=f-800
25 ifk$="i"andf>=3200thengosub27:ifep<1thencl$="{orange}":gosub31:f=f-3200
26 return

!- If zone can be placed
27 ep=.:c9=((v0-1)*s+(h0-1))+g:forz0=.to2:forz1=.to2:ifpeek(c9+(z0*s)+z1)<>32thenep=ep+1
28 ifv0<2orv0>21orh0<1orh0>38thenep=ep+1
29 nextz1,z0:ifpeek(g+v0*s+h0)=32thenep=ep-1
30 return

!- Draw zone
31 windowh0-1,v0-1,h0+1,v0+1,1:printcl$"O{cm y}P{cm g}{reverse on}"k$"{reverse off}{cm m}L{cm p}{186}":return

!- Draw HUD line
32 print"{reverse on}{C*38}";:return

!- Check random city plots for zone plots
33 k=int(rnd(1)*40):k=int(rnd(.)*21)*40+k
34 d=peek(g+k):ifd=79ord=119ord=80ord=101ord=103ord=76ord=111ord=122thengosub38
35 ifd=207ord=247ord=208ord=229ord=231ord=204ord=239ord=250ord=146ord=137ord=131thengosub47
36 ife9>12thene9=.:y=y+1:f=f+r0*200+c0*400+i0*800+r1*400+c1*800+i1*1600
37 return

!- Activate plots tier 1 zone
38 e0=.:e1=.:forz0=.to2:forz1=.to2:pc=peek((g+k-41)+(z0*s)+z1):ifpc=146thene0=1
39 ifpc=131thene0=2
40 ifpc=137thene0=3
41 ifpc=186thene1=1
42 nextz1,z0:ife1=.thenreturn

43 ife0=1thenr0=r0+1:poke(g+k),d+128
44 ife0=2thenc0=c0+1:poke(g+k),d+128
45 ife0=3theni0=i0+1:poke(g+k),d+128
46 return

!- Update plots to tier 2 zone
47 ifd=146thenpoke(c+k),5:return
48 ifd=131thenpoke(c+k),6:return
49 ifd=137thenpoke(c+k),7:return
50 d=peek(c+k):if(dand13)=13thenr=r2:r0=r0-1:r1=r1+1:pokec+k,5:return
51 if(dand14)=14thenc=c2:c0=c0-1:c1=c1+1:pokec+k,6:return
52 if(dand8)=8theni=i2:i0=i0-1:i1=i1+1:pokec+k,7:return
53 return

!- Remove plot
54 d=peek(g+v0*s+h0):ifd=207ord=247ord=208ord=229ord=231ord=204ord=239ord=250ord=146ord=137ord=131ord=186then61
55 d=peek(c+k):if(dand13)=13thenr0=r0-1:goto61
56 if(dand5)=5thenr1=r1-1:goto61
57 if(dand14)=14thenc0=c0-1:goto61
58 if(dand6)=6thenc1=c1-1:goto61
59 if(dand8)=8theni0=i0-1:goto61
60 if(dand7)=7theni1=i1-1
61 f=f-100:poke(g+v0*s+h0),32:return

!- Load game
62 open5,bd,8,"simcity.sav,s,r":input#5,y:input#5,f:input#5,e9:input#5,r0:input#5,r1:input#5,c0:input#5,c1:input#5,i0:input#5,i1:input#5,h::input#5,v:close5
63 on(bd-7)gosub64,65,66,67:return
64 bload"simcity.scr",d0,u8,b0,p1024:bload"simcity.scl",d0,u8,b15,p55296:return
65 bload"simcity.scr",d0,u9,b0,p1024:bload"simcity.scl",d0,u9,b15,p55296:return
66 bload"simcity.scr",d0,u10,b0,p1024:bload"simcity.scl",d0,u10,b15,p55296:return
67 bload"simcity.scr",d0,u11,b0,p1024:bload"simcity.scl",d0,u11,b15,p55296:return

!- Save game
68 open5,bd,15,"s0:simcity.sav":close5:open5,bd,15,"s0:simcity.scr":close5:open5,bd,8,"s0:simcity.scl":close5:open5,bd,8,"simcity.sav,s,w":print#5,int(y):print#5,f:print#5,e9:print#5,r0:print#5,r1:print#5,c0:print#5,c1:print#5,i0:print#5,i1:print#5,h::print#5,v:close5
69 on(bd-7)gosub70,71,72,73:return
70 bsave"simcity.scr",d0,u8,b0,p1024top1864:bsave"simcity.scl",d0,u8,b15,p55296top56136:return
71 bsave"simcity.scr",d0,u9,b0,p1024top1864:bsave"simcity.scl",d0,u9,b15,p55296top56136:return
72 bsave"simcity.scr",d0,u10,b0,p1024top1864:bsave"simcity.scl",d0,u10,b15,p55296top56136:return
73 bsave"simcity.scr",d0,u11,b0,p1024top1864:bsave"simcity.scl",d0,u11,b15,p55296top56136:return

!- SIMCITY intro
74color4,1:color.,10:sprite1,.:window.,.,39,24:print"{clear}"tab(19)"{black}{reverse on}:{return}"tab(5)"{light gray}{reverse off}{cm d}{cm i*9}{cm f}"tab(19)"{black}{reverse on}:{return}"tab(5)"{light gray}{reverse on}{cm k}{green}         {reverse off}{light gray}{cm k}"tab(19)"{black}{reverse on}:{return}"tab(5)"{light gray}{reverse on}{cm k}{green} simcity {reverse off}{light gray}{cm k}"tab(19)"{black}{reverse on}:{reverse off}{right*3}{purple}{cm asterisk}{sh pound} {cyan}triangular{return}"tab(5)"{light gray}{reverse on}{cm k}{green}         {reverse off}{light gray}{cm k}"tab(19)"{black}{reverse on}:{reverse off}{right*6}{cyan}(c) 2024{return}"tab(5)"{light gray}{reverse off}{cm c}{reverse on}{cm i}{cm d}{cm i*5}{cm f}{cm i}{reverse off}{cm v}"tab(19)"{black}{reverse on}:"
75printtab(7)"{light gray}{reverse off}{cm k}"tab(13)"{reverse on}{cm k}"tab(19)"{black}{reverse on}:{return}"tab(19)"{reverse on}:{return}"tab(4)"{light green}earns:$200 {green}$400{black}"tab(19)"{reverse on}:{reverse off}{light blue}$400 {blue}$800{black}{return}"tab(11)"{reverse on}{black}:::::::::::::::::{return}"tab(11)"{black}{reverse on}:{reverse off}{light green}O{cm y}P{black}{reverse on}:{reverse off}{green}O{cm y}P{reverse on}{black}:{reverse off}{light blue}O{cm y}P{black}{reverse on}:{reverse off}{blue}O{cm y}P{black}{reverse on}:{reverse off}{return}  {light green}cost:$200{black}{reverse on}:{reverse off}{light green}{cm g}r{reverse off}{cm m}{black}{reverse on}:{reverse off}{green}{cm g}{reverse on}r{reverse off}{cm m}{reverse on}{black}:{reverse off}{light blue}{cm g}{reverse on}c{reverse off}{cm m}{black}{reverse on}:{reverse off}{blue}{cm g}{reverse on}c{reverse off}{cm m}{black}{reverse on}:{reverse off}{blue}cost:$800"
76printtab(11)"{black}{reverse on}:{reverse off}{light green}L{cm p}{186}{black}{reverse on}:{reverse off}{green}L{cm p}{186}{reverse on}{black}:{reverse off}{light blue}L{cm p}{186}{black}{reverse on}:{reverse off}{blue}L{cm p}{186}{black}{reverse on}:{return}{reverse on}{black}::::::::::::::::::::::::::::::::::::::::{return}"tab(19)"{reverse on}{black}:{reverse off}{orange}O{cm y}P{reverse on}{black}:{reverse off}{yellow}O{cm y}P{reverse on}{black}:{return}{right*4}{red}{reverse off}V $100   {reverse on}{black}:{reverse off} $10 {reverse on}:{reverse off}{orange}{cm g}{reverse on}i{reverse off}{cm m}{reverse on}{black}:{reverse off}{yellow}{cm g}{reverse on}i{reverse off}{cm m}{reverse on}{black}:{reverse off}{yellow}cost:$3200{return}{right*4}{red}{reverse off}remove   {black}road "tab(19)"{reverse on}{black}:{reverse off}{orange}L{cm p}{186}{reverse on}{black}:{reverse off}{yellow}L{cm p}{186}{reverse on}{black}:{reverse off}{return}"tab(19)"{reverse on}{black}:::::::::"
77printtab(13)"{orange}earns:{black}{reverse on}:{reverse off}{orange}$800 {yellow}$1600{return}"tab(19)"{reverse on}{black}:{return}"tab(19)"{reverse on}{black}:{reverse off}{return}  {reverse on}{green}f1{reverse off}{white} start"tab(19)"{reverse on}{black}:{reverse off}  {white}{reverse off}move: {cyan}joystick{return}"tab(19)"{reverse on}{black}:{reverse off}  {white}{reverse off}keys: {black}space {red}del{return}  {reverse on}{red}f8{reverse off}{white} exit/menu"tab(19)"{reverse on}{black}:{reverse off}  {white}zone: {green}r{right}{blue}c{right}{yellow}i{return}"tab(19)"{reverse on}{black}:":poke208,.
78getk$:ifk$="{f8}"then81
79ifk$="{f1}"then12
80goto78

!- Load program
81fast:print"{home*2}{clear}{142}";:color4,1:color.,1:sprite1,.:movspr8,.#.:movspr8,160,170:sprite8,1,1,.,1,.,.
82printleft$(v$,15)tab(17)"{purple}{reverse off}{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"      loading...":slow:print"{home}{black}load "q$"gui"q$","peek(3000):poke208,.:fori=.to5:g=peek(3051+i):poke842+i,g:nexti:poke208,6:new
