!- TRIANGULAR μOS 1.42 for Commodore 128
!- STAR WARS


!- STAR WARS start & set up
0j=.:m=.:h8=26:v8=52:h7=338:v7=244:q$=chr$(34):bd=peek(3000):g=peek(2619)*256:s=54272:v$="{down*24}":h$="{right*40}":s$="{space*40}":gosub70:goto13

!- Joystick air steering
1return
2v5=v5-m:ifv5<50thenv5=50:return:elsereturn
3gosub2:gosub4:return
4h5=h5+m:ifh5>320thenh5=320:return:elsereturn
5gosub4:gosub6:return
6v5=v5+m:ifv5>144thenv5=144:return:elsereturn
7gosub6:gosub8:return
8h5=h5-m:ifh5<24thenh5=24:return:elsereturn
9gosub2:gosub8:return


!- Turn off, reset and move all sprites to bottom-right corner
10fori=1to8:spritei,.:movspri,.#.:poke2039+i,55+i:movspri,511,255:nexti:return

!- Clear SID registers
11vol.:fori=1to3:soundi,.,.,.,.,.,.,.:nexti:return

!- Beep sound
12sound1,k,10,.,.,.,.,.:forj=.to50:nextj:return


!- STAR WARS: X-Wing vs TIE Fighter intro
13 fast:print"{home*2}{clear}{142}{27}l":gosub10:color4,1:color.,1:print"{clear}":m=6:v5=144:h5=170:l9=.
14 print"{clear}{ct n}"left$(v$,11)"{cyan}  A long time ago in a galaxy far,{return}  far away....":slow:poke208,.:gosub33:print"{clear}";:gosub32:printleft$(v$,22)"{yellow} Young Luke Skywalker must find":gosub32:print:gosub32:print" Death Star to save galaxy.":gosub32:print
15 gosub32:print" First, he must destroy enemy TIE":gosub32:print:gosub32:print" Fighters in order to catch Darth Vader.":forj=.to25:gosub32:print:nextj

!- Title screen
16 fast:print"{clear}{27}m{down}"tab(4)"{142}{yellow}{right*3}N{cm y*9}P O{cm y*2}P{right*3}O{cm y*4}M{return}"tab(7)"{cm g}{right*2}{cm p*3}{right*2}{cm p*2}{sh @}H {cm m}{cm g} G{right*2}{cm g}{right*4}{cm m}{return}"tab(7)"M{right*2}M{right*2}{cm g}{cm m}{right*3}G HG H{right*2}{cm g}{cm m}{cm y*2}{cm g}{cm m}{return}"tab(8)"M{right*2}G {cm g}{cm m}{right*3}{cm g} GH {cm m}{right*2}{cm g} {cm y*2} N{return}"tab(8)"{cm m}{right*2}H {cm g}{cm m}{right*2}H{right*2}L{sh @}{right*2}G {cm g}{cm m}M{right*2}M{return}"tab(4)"O{cm y*4}{right*2}G {cm g}{cm m}{right*2}G{right*6}H {cm g}{cm m} M{right*2}{cm y*3}P{return}"tab(4)"L{cm p*5}N{right*2}L{sh @}{right*2}L{cm p}O{cm y*2}P{cm p}{sh @} L{sh @}{right*2}M{cm p*4}{sh @}{down}"
17 printtab(4)"OP OP OP{right*2}O{cm y*2}P{right*3}O{cm y*4}M{right*2}N{cm y*5}P{return}"tab(4)"G G{cm g}{cm m}H H H {cm m}{cm g} G{right*2}{cm g}{right*4}{cm m}{right*2}{cm g}{right*2}{cm p*3}{sh @}{return}"tab(4)"H H{right*2}G G G HG H{right*2}{cm g}{cm m}{cm y*2}{cm g}{cm m}{right*2}M{right*2}M{return}"tab(4)"{cm m}{right*5}{cm m}{right*2}{cm g} GH {cm m}{right*2}{cm g} {cm y*2} N{right*3}M{right*2}G{return}"tab(4)" G {cm m}{cm g} H H{right*2}L{sh @}{right*2}G {cm g}{cm m}M{right*2}M{right*3}{cm m}{right*2}H{return}"tab(4)" H GH G G{right*6}H {cm g}{cm m} M{right*2}{cm y*4}{right*2}G"
18 printtab(4)"{right*2}L{cm g}{cm m}{sh @}{right*2}L{cm p}O{cm y*2}P{cm p}{sh @} L{sh @}{right*2}M{cm p*6}N{down}{return}{red}"left$(h$,9)"{cm d}{cm i*21}{cm f}{reverse off}{return}"left$(h$,9)"{reverse on}{cm k}x-wing vs tie fighter{reverse off}{cm k}{return}"left$(h$,9)"{cm c}{reverse on}{cm i*21}{reverse off}{cm v}"
19 print"{down*1}{cyan}{right*4}(c)2024 {purple}{cm asterisk}{sh pound} {cyan}triangular, lucasarts{return}{down*2}"tab(29)"{reverse on}{green}f1{reverse off}{white} continue";:restore20:k=.:slow:poke208,.
20 do:getk$:ifl9>16thenl9=.:restore20:datac,4,320,g,4,400,f,4,240,e,4,240,d,4,240,c,5,440,g,4,240,f,4,240,e,4,240,d,4,240,c,5,440,g,4,240,f,4,240,e,4,240,f,4,240,d,4,600,0,4,150
21 gosub30:l9=l9+1:loopwhilek$<>"{f1}"

!- Main menu
22 fast:print"{clear}{27}l{down}"left$(h$,15)"{yellow}star wars{down}{return}{down}"left$(h$,9)"{red}x-wing vs tie fighter{down*2}{return}"left$(h$,24)"{reverse off}{white}N   M{return}{right*6}{light gray}{cm c}D{sh asterisk}R{red}Q{light gray}{cm i}{red}Q{light gray}R{sh asterisk}D{cm v}{right*7}{reverse off}{white}{cm g}{reverse on}{sh pound}"q$;q$"{left}{cm asterisk}{reverse off}{cm m}{return}{right*10}{light gray}{cm m}{reverse on} {reverse off}{cm g}{right*11}{reverse off}{white}O{cm asterisk}{reverse on}W{reverse off}{sh pound}P{return}{right*6}{light gray}{cm d}R{sh asterisk}D{red}Q{reverse on}{light gray}{cm i}{reverse off}{red}Q{light gray}D{sh asterisk}R{cm f}{right*7}{reverse off}{white}M  {green}N{down}{left*3}N{up}{right*2}{white}N{return}"
23 print"{right}{white}{down}mission:{return}{cyan}{right*2}luke, you have to find death star.{return}{right*2}to do so, you must destroy{return}{right*2}20 tie fighters.{return}{down}{yellow} move: {white}joystick{return}{down*2}{reverse on}{green}f1{reverse off}{white} start{return}{down}{reverse on}{red}f8{reverse off}{white} exit/menu":slow:poke208,.
24 getk$:ifk$="{f1}"then37
25 ifk$="{f8}"then68
26 goto24

!- Music theme
27 mx$="0":md=250:sc$="4"
28 ifmx$<>"0"thenso$="v1o"+sc$+"t7x0"+mx$:playso$
29 fori=.tomd/(2+k):nexti:return
30 k=2:gosub31:return
31 readmx$,sc$,md:gosub28:gosub27:return

!- Wait or check for F1 key
32 poke208,.:y=.:f9=10:goto34
33 poke208,.:y=.:f9=100
34 y=y+1:getk$:ify>f9thenreturn
35 ifk$<>"{f1}"then34
36 goto16

!- Draw random stars
37 fast:print"{blue}{clear}":fori=.to50:j=int(rnd(.)*680):pokeg+j,46:nexti

!- Draw cocpit
38 print"{home}"left$(v$,14)"{dark gray}{reverse on}{cm asterisk}"tab(39)"{sh pound} {reverse on}{cm asterisk}"tab(38)"{reverse on}{sh pound} {reverse off}{cm asterisk}{reverse on} {cm asterisk}"tab(37)"{reverse on}{sh pound} {reverse off}{sh pound}{right}{cm asterisk}{reverse on} {cm asterisk}"tab(36)"{reverse on}{sh pound} {reverse off}{sh pound}{return}{reverse on}{right*2}{reverse on}"left$(s$,36)"{return}{right}{reverse on}{sh pound} {reverse off}{sh pound}"tab(36)"{cm asterisk}{reverse on} {cm asterisk}{return}{reverse on}{sh pound} {reverse off}{sh pound}"tab(37)"{cm asterisk}{reverse on} {cm asterisk} {reverse off}{sh pound}"tab(38)"{cm asterisk}{reverse on} {reverse off}{sh pound}"tab(39)"{cm asterisk}"
39 print"{home}{gray}"left$(v$,19)tab(4)"{cm a}{sh asterisk*6}{cm s}{right}{cm a}{sh asterisk*12}{cm s}{right}{cm a}{sh asterisk*6}{cm s}{home}"left$(v$,20)tab(4)"{B}{reverse on}{purple} time {reverse off}{gray}{B}{right}{B}{reverse on}{cyan}   target   {reverse off}{gray}{B}{right}{B}{reverse on}{red}damage{reverse off}{gray}{B}{home}"left$(v$,21)tab(4)"{B}{right*6}{B}{right}{B}{right*12}{B}{right}{B}{right*6}{B}{home}"left$(v$,22)tab(4)"{B}{purple} 1000 {gray}{B}{right}{B}{cyan}{white}{right*8}{cyan}20  {gray}{B}{right}{B}{red} 100% {gray}{B}"
40 print"{home}"left$(v$,23)tab(4)"{B}      {gray}{B}{right}{B}{right*12}{B}{right}{B}{right*6}{B}{home}"left$(v$,24)tab(4)"{cm z}{sh asterisk*6}{cm x}{right}{cm z}{sh asterisk*12}{cm x}{right}{cm z}{sh asterisk*6}{cm x}";:movspr7,144,221:sprite7,1,2,1,.,.,.:sc=20:sf=1000:df=100:poke2046,56:slow

!- STAR WARS game loop
41 movspr2,h5,v5:poke2040,56:movspr1,int(rnd(.)*296+24),int(rnd(.)*114+50):sprite1,1,2,.,.,.,.:sprite2,1,4,.,.,.,.:sprite3,.:
42 j=joy(2):ifjand128then62
43 on(jand15)+1gosub1,2,3,4,5,6,7,8,9
44 movspr1,int(rnd(.)*360)#1:i=rsppos(1,.):k=rsppos(1,1):ifi<24ori>320ork<50ork>144thenbegin
45 ifi<34thenmovspr1,34,k
46 ifi>310thenmovspr1,310,k
47 ifk<60thenmovspr1,i,60
48 ifk>134thenmovspr1,i,134
49 bend
50 movspr2,h5,v5:getk$:ifk$="{f8}"thengosub10:goto13
51 ifint(rnd(.)*80)=.then66
52 gosub54:ifsf<1ordf<1then67
53 goto42


!- Update cocpit parameters
54 sf=sf-1:print"{home}"left$(v$,22)tab(5)"{purple}"sf"{left} "tab(20)"{cyan}"sc"{left} "tab(29)"{red}"df"{left}% ":return


!- STAR WARS outro
55 fast:print"{clear}"left$(v$,11)"{ct n}{yellow} Luke Skywalker completes his battle{return}{down} with Darth Vader's forces.{return}{down} Now Luke is ready to confront him.":slow
56 sleep5:fast:print"{clear}{142}{purple}{return}"tab(14)"FCDDCF{cm p}{return}"tab(13)"N HG{space*4}M{return}"tab(13)"{cm g} {cm g*2}{space*4}{cm m}{return}"tab(12)"N{space*2}{cm g*2}{space*5}{cm g}{return}"tab(11)"N{cm y}C{cm e*2}CEC{space*3}G{return}"tab(10)"{cm m} < )({cm p} >{cm y}M G{return}"tab(10)"H FC{space*2}{cm p}{sh asterisk*2}{cm x} {cm g}H{return}"tab(10)"G FNhtM{sh asterisk}N{space*2}G M{return}"tab(9)"{cm m}{space*2}UN{cm r}t{cm r} NN H {cm m}{return}"tab(9)"M{space*2}JK{cm y*3}JK{space*3}{cm y}M{cm g}{return}"tab(10)"EC{sh asterisk}{cm s}{space*3}NC{cm s} {cm a}C{cm x}"
57 printtab(11)"{cm p}N{space*3}{cm z}DE{space*3}M{return}"tab(9)"FC{space*3}={space*8}C{sh asterisk}F{cm p}{return}"tab(7)"N{cm y}{space*4}N {cm g} {cm m} M{space*7}{cm y}M{return}"tab(6)"N{space*5}GG {cm g} {cm m} {cm m}{space*9}M"
58 printtab(5)"N{space*4}H{space*2}U {cm g} I {cm m}{space*10}M{return}"tab(5)"{cm g}{space*4}G{space*2}{sh -}{space*3}{sh -} H{space*10}{cm m}{return}"tab(4)"N{space*5}{cm z}{space*2}{sh -}{space*5}G{space*11}G{return}"tab(4)"{cm g}{space*6}ED{sh asterisk}FF{sh asterisk*2}{cm x}{space*12}H{return}"tab(3)"{cm m}{space*7}O{cm y*8}P{space*10}H{return}"tab(3)"G{space*6}{cm m} {cm m}{cm a}{cm r}{cm s}{space*2}UI{cm g*2}{space*9}{cm m}{return}"tab(3)"G{space*6}{cm m} {cm m}{cm a}{cm r}{cm s}{space*2}JK{cm g*2}{space*10}G":slow
59 sleep2:print"{home}{white}{down*3}"tab(26)"{reverse on}{space*13}{return}"tab(26)"{reverse on} luke, i'm{space*3}{return}"tab(26)"{reverse on}{space*13}{return}"tab(25)"{reverse on}{sh pound} your father {return}"tab(24)"{reverse on}{sh pound}{space*14}":pokes+5,15:pokes+1,30:pokes+4,129:fori=.to5:pokes+1,30+(-2)*i:forj=.to40:nextj:nexti:pokes+4,.:pokes+1,.:sleep3
60 fast:print"{clear}"left$(v$,10)"{yellow}{space*3}O{cm y*3}P O{cm g} O{cm g}O{cm y*2}P{space*3}O{cm y*2}P{cm m}{cm y}{cm g} O{cm g}O{cm y*3}M{return}{space*3}{cm y}P O{cm y} {cm g}L{cm p}{cm g*3}O{cm y*2}{space*3}{cm g}O{cm y*2}{cm m} M {cm g*3}O{cm y}M{cm m}{return}{space*4}{cm m} {cm g}{space*2}{cm g}{cm p*2} {cm g*2}{cm y*2}P{space*3}{cm g}{cm y*2}P{cm m*2}{M*2}{cm g*4} {cm m*2}{return}{space*4}{cm m} {cm g}{space*2}{cm g*2} {cm g*3}O{cm y*2}{space*3}{cm g}O{cm y*2}{cm m*2} M {cm g*2}L{cm p}N{cm m}{return}{space*4}{cm m} {cm g}{space*2}{cm g*2} {cm g*3}{cm y*2}P{space*3}{cm g}{cm y*2}P{cm m*2}{space*2}{cm g*3}{space*3}N{return}{space*5}{cm y}{space*3}{cm y}{space*2}{cm y} {cm y*4}{space*3}{cm y*4} {cm y}{space*2}{cm y} {cm y*4}":slow
61 restore20:forj=.to16:gosub30:nextj:fast:print"{clear}{down*2}{cyan}"tab(17)"credits{down*2}":printtab(4)"star wars x-wing vs tie fighters{return}{return}{down*4}{space*7}(c) triangular, lucasarts{return}"tab(13)"{down*3}(c) 2024, 1980":slow:restore20:forj=.to16:gosub30:nextj:print"{clear}":poke208,.:goto13

!- Fire
62 sprite2,.:fori=.to50:nexti:movspr4,rsppos(2,.)+12,170:movspr4,.#8:bm=bump(1):pokes+1,30:pokes+5,136:pokes+6,160:pokes+4,17:k=150:sprite4,1,3,1,1,1,.:do:bm=bump(1):if(bmand1)<>.thenexit
63 loopwhile(rsppos(4,1)>rsppos(2,1)):sprite4,.:movspr4,.#.:sprite2,1,4,.,.,.,.:pokes+4,.:if(bmand1)=.then42

!- Shoot down
64 sprite4,.:movspr4,.#.:sc=sc-1:movspr1,.#.:poke2040,58:movspr1,140#1:restore64:pokes+5,15:pokes+1,30:pokes+4,129:fori=.to5:readk:sprite1,1,k:pokes+1,30+(-2)*i:forj=.to30:nextj:nexti:pokes+4,.:pokes+1,.:sleep1:sprite1,.:sprite2,1,4,.,.,.,.:ifsc=.thengosub10:goto55:data8,9,3,10,13,12
65 sprite4,.:goto41

!- TIE shooting
66 movspr1,.#.:movspr5,rsppos(1,.)+5,rsppos(1,1)+20:movspr5,180#8:sprite5,1,6,1,1,1,.:pokes+1,30:pokes+5,136:pokes+6,255:pokes+4,17:k=150:dountil(rsppos(5,1)>180):loop:sprite5,.:pokes+4,.:df=df-5:goto52

!- Game Over
67 fast:gosub10:print"{clear}"left$(v$,12)tab(16)"{ct n}{red}G A M E{down*2}{left*7}O V E R":slow:k=3608:gosub12:k=2864:gosub12:k=3608:gosub12:sleep3:goto13

!- Load program
68fast:print"{home*2}{clear}{142}";:color4,1:color.,1:gosub10:gosub75:movspr8,.#.:movspr8,160,170:sprite8,1,1,.,1,.,.
69printleft$(v$,15)tab(17)"{purple}{reverse off}{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"      loading...":slow:print"{home}{black}load "q$"gui"q$","peek(3000):poke208,.:fori=.to5:g=peek(3051+i):poke842+i,g:nexti:poke208,6:new


!- CRAB IN NYC.SPR asset file loading [on bd-7 {boot drive} gosub x {}]
70on(bd-7)gosub71,72,73,74:return
71bload"star wars.spr",d0,u8,b0,p3584:return
72bload"star wars.spr",d0,u9,b0,p3584:return
73bload"star wars.spr",d0,u10,b0,p3584:return
74bload"star wars.spr",d0,u11,b0,p3584:return

!- GUI.SPR asset file loading [on bd-7 {boot drive} gosub x {}]
75on(bd-7)gosub76,77,78,79:return
76bload"gui.spr",d0,u8,b0,p3584:return
77bload"gui.spr",d0,u9,b0,p3584:return
78bload"gui.spr",d0,u10,b0,p3584:return
79bload"gui.spr",d0,u11,b0,p3584:return
